{% extends 'profile/ppbd/layouts/admin/admin_layout.html' %}

{% load static %}
{% block css %}
    <link rel="stylesheet" type="text/css" href="{% static 'admin/css/cropper/cropper.min.css' %}">
    <style>
        .crop-preview > canvas {
            width: 100%;
            height: auto;
        }
        .django-ckeditor-widget{ width: 100% !important; }
        #cke_id_description { width: 100% !important; }
        .kotak-pdf {
            max-height: 250px !important;
            width: 100%;
            overflow-y: auto; 
            border: 1px solid #f2f2f2;
            background-color: #f2f2f2;
    
            background-image: url("{% static 'admin/images/no-project-images.jpg' %}");
            background-repeat: no-repeat;
            background-size: cover;
            background-position: center;
        }
    </style>
{% endblock css %}

{% block scripts %}
    {% load static %}
    <script type="text/javascript" src="{% static 'ckeditor/ckeditor-init.js' %}"></script>
    <script type="text/javascript" src="{% static 'ckeditor/ckeditor/ckeditor.js' %}"></script>
{% endblock scripts %}

{% block navbar %}
    {% include 'profile/layouts/admin/navbar.html' %}
{% endblock navbar %}

{% block main %}
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{% url 'profile:adm_ppdb_index' %}">Home</a></li>
            <li class="breadcrumb-item active" aria-current="page">Setting Beranda</li>
        </ol>
    </nav>

    {% if messages %}
        {% for message in messages %}
            <div class="alert {{ message.tags }} my-2" role="alert">
                {{message}}
                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>  
        {% endfor %}
    {% endif %}
    
    <div class="card mb-5 shadow">
        <h5 class="card-header">Setting Beranda</h5>
        <div class="card-body">
            {% if edit %}
                {% if news.image %}
                    <div class="col col-md-12 mb-2 text-center" id="old-image">
                        <img class="img-responsive center-block" style="max-width: 100%; max-height: 100%;" src="{{news.image.url}}" alt="">
                        <p><small>File foto lama.</small></p>
                    </div>
                {% endif %}
            {% endif %}
            {% include 'profile/ppbd/layouts/admin/beranda/form.html' %}
        </div>
    </div>
{% endblock main %}

{% block footer %}
    {% include 'profile/layouts/admin/footer.html' %}
{% endblock footer %}

{% block scripts_bawah %} 
    <script src="{% static 'admin/js/cropper/cropper.min.js' %}"></script>
    <script src="{% static 'admin/js/cropper/jquery-cropper.min.js' %}"></script>
    <script src="{% static 'admin/js/pdfjs/pdf.js' %}"></script>
    <script>
        var pdfjsLib = window['pdfjs-dist/build/pdf'];
        pdfjsLib.GlobalWorkerOptions.workerSrc = "{% static 'admin/js/pdfjs/pdf.worker.js' %}";

        $( document ).ready(function() {
            $("#foto").val('');
            $("#if_foto").val('False');
            $("#if_katalog").val('False');

            $(".modal-close").click(function(){
                $("#foto").val(null);
            });

            if($("#if_edit").attr('alt') == 'true'){
                $("#foto").prop('required',false);
                if($("#pdfViewer").attr('alt') != ''){ render_pdf($("#pdfViewer").attr('alt')); }
                
                // var gambaaar = $("#crop_preview").attr('alt');
                // document.getElementById('crop_preview').innerHTML = '<img src="'+gambaaar+'" width="100%"/>';
            }

            $("#foto").change(function () {
                if (this.files && this.files[0]) {
                    let reader = new FileReader();
                    
                    let fileFoto = this.files[0];
                    let namafile = fileFoto.name;
                    let fileType = (fileFoto.type).toLowerCase();
                    let arryType = ['image/png','image/jpg','image/jpeg','image/gif'];

                    if(!arryType.includes(fileType)){
                        Swal.fire('Peringatan !!', 'Type file bukan PNG/JPG/JPEG/GIF, type file anda [*.'+fileFoto.type+']', 'warning');
                        $("#foto").val('');
                    } else if(fileFoto.size > 2100000){ //maks file 2 MB
                        Swal.fire('Peringatan !!', 'File foto terlalu besar, maksimal 2MB', 'warning');
                        $("#foto").val('');
                    } else {
                        $(this).next('.custom-file-label').html(namafile);
                        reader.onload = function (e) {
                            $("#image").attr("src", e.target.result);
                            $("#modalCrop").modal("show");
                        }
                        reader.readAsDataURL(this.files[0]);
                    };
                }
            });

            let $image = $("#image");
            let cropBoxData;
            let canvasData;

            $("#modalCrop").on("shown.bs.modal", function () {
                $image.cropper({
                    viewMode: 1,
                    aspectRatio: 2/2,
                    minCropBoxWidth: 200,
                    minCropBoxHeight: 200,
                    ready: function () {
                        $image.cropper("setCanvasData", canvasData);
                        $image.cropper("setCropBoxData", cropBoxData);
                }
            });

            }).on("hidden.bs.modal", function () {
                cropBoxData = $image.cropper("getCropBoxData");
                canvasData = $image.cropper("getCanvasData");
                $image.cropper("destroy");
            });

            // Enable zoom in button
            $(".js-zoom-in").click(function () {
                $image.cropper("zoom", 0.1);
            });

            // Enable zoom out button
            $(".js-zoom-out").click(function () {
                $image.cropper("zoom", -0.1);
            });

            $(".js-crop-and-upload").click(function () {
                var cropData = $image.cropper("getData");
                $("#id_x").val(cropData["x"]);
                $("#id_y").val(cropData["y"]);
                $("#id_height").val(cropData["height"]);
                $("#id_width").val(cropData["width"]);
                $("#modalCrop").modal('hide');
                let data;
                let croppedimage = $image.cropper("getCroppedCanvas")
                $(".crop-preview").html(croppedimage);
                $("#old-image").addClass('d-none');
                $("#old-image").hide();
                $("#if_foto").val('True');
            });
        });

        $("#dokumen").on("change", function(e){
            var file = e.target.files[0]
            if(file.type == "application/pdf"){
                var fileReader = new FileReader();  
                fileReader.onload = function() {
                    var pdfData = new Uint8Array(this.result);
                    // Using DocumentInitParameters object to load binary data.
                    render_pdf({data: pdfData});
                    $("#if_katalog").val('True');
                };
                fileReader.readAsArrayBuffer(file);
            }
        });

        function render_pdf(toko_src){
            var loadingTask = pdfjsLib.getDocument(toko_src);
            loadingTask.promise.then(function(pdf) {
              console.log('PDF loaded');
              
              // Fetch the first page
              var pageNumber = 1;
              pdf.getPage(pageNumber).then(function(page) {
                console.log('Page loaded');
                
                var scale = 0.8;
                var viewport = page.getViewport({scale: scale});

                // Prepare canvas using PDF page dimensions
                var canvas = $("#pdfViewer")[0];
                var context = canvas.getContext('2d');
                canvas.height = viewport.height;
                canvas.width = viewport.width;

                // Render PDF page into canvas context
                var renderContext = {
                  canvasContext: context,
                  viewport: viewport
                };
                var renderTask = page.render(renderContext);
                renderTask.promise.then(function () {
                  console.log('Page rendered');
                });
              });
            }, function (reason) {
              // PDF loading error
              console.error(reason);
            });
        }
    </script>
{% endblock scripts_bawah %}